package com.friday.custody.service.basicService.impl;

import com.friday.custody.enums.DataDictionaryTypeEnum;
import com.friday.custody.service.basicService.DataDictionaryExchangeCodeService;
import com.friday.custody.service.logicService.DataDictionaryBasicService;
import com.friday.custody.utils.PageUtils;
import com.friday.custody.utils.Query;
import com.friday.custody.utils.R;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;

import com.friday.custody.dao.DataDictionaryExchangeCodeDao;
import com.friday.custody.entity.DataDictionaryExchangeCodeEntity;
import org.springframework.util.CollectionUtils;


@Service("dataDictionaryExchangeCodeService")
public class DataDictionaryExchangeCodeServiceImpl extends ServiceImpl<DataDictionaryExchangeCodeDao, DataDictionaryExchangeCodeEntity>
        implements DataDictionaryExchangeCodeService, DataDictionaryBasicService {

    @Override
    public PageUtils queryPage(Map<String, Object> params) {
        IPage<DataDictionaryExchangeCodeEntity> page = this.page(
                new Query<DataDictionaryExchangeCodeEntity>().getPage(params),
                new QueryWrapper<DataDictionaryExchangeCodeEntity>()
        );

        return new PageUtils(page);
    }

    @Override
    public Map<String, String> queryWithDetail(DataDictionaryTypeEnum dicType, String trustNo) {
        return null;
    }

    @Override
    public Map<String, String> queryWithDetail(String trustNo) {
        return null;
    }

    @Override
    public R queryData(String type) {
        List<DataDictionaryExchangeCodeEntity> entities = baseMapper.selectList(new QueryWrapper<>());
        if (!CollectionUtils.isEmpty(entities)) {
            return R.ok("查询字典信息成功！")
                    .put("data", entities.stream().collect(Collectors.toMap(DataDictionaryExchangeCodeEntity::getKeyStr
                            ,DataDictionaryExchangeCodeEntity::getValue)));
        }
        return R.ok("字典信息为空，请联系管理员配置！");
    }
}